package aggSim.analyzer;

import ronmodel.Mapping;
import ronmodel.ONTransition;
import aggSim.NetMorphism;

public class Conflict {
	public final static int TRANSITION_TRANSITION_CONFLICT = 0;
	public final static int RULE_TRANSITION_CONFLICT = 1;
	public final static int TRANSITION_RULE_CONFLICT = 2;
	public final static int RULE_RULE_CONFLICT = 3;

	private final Object first;
	private final Object second;
	private final int conflictType;

	/**
	 * @param conflictType
	 * @param first
	 * @param second
	 */
	public Conflict(final int conflictType, final Object first,
			final Object second) {
		this.conflictType = conflictType;
		this.first = first;
		this.second = second;
	}

	/**
	 * @return the conflictType
	 */
	public int getConflictType() {
		return conflictType;
	}

	/**
	 * @return the first
	 */
	public Object getFirst() {
		return first;
	}

	/**
	 * @return the second
	 */
	public Object getSecond() {
		return second;
	}

	@Override
	public String toString() {
		final StringBuilder result = new StringBuilder();
		result.append("1: ");
		if (first instanceof ONTransition) {
			result.append(((ONTransition) first).getName());
		} else {
			for (final Mapping mapping : (NetMorphism) second) {
				result.append(mapping.getTarget().getName());
				result.append(" - ");
			}
		}
		result.append("\n2: ");
		if (second instanceof ONTransition) {
			result.append(((ONTransition) second).getName());
		} else {
			for (final Mapping mapping : (NetMorphism) second) {
				result.append(mapping.getTarget().getName());
				result.append(" - ");
			}
		}
		return result.toString();
	}

}
