package roneditor.gef.actions;

import muvitorkit.actions.MuvitorActionBarContributor;

import org.eclipse.jface.action.IMenuManager;
import org.eclipse.jface.action.IToolBarManager;
import org.eclipse.jface.action.Separator;
import org.eclipse.ui.actions.RetargetAction;

import roneditor.RONIconUtil;

public class RONEditorActionBarContributor extends MuvitorActionBarContributor {

	public static final String FIRE_TRANSITION_ACTION_ID = "roneditor.actions.FireTransitionAction";

	public static final String FIRE_TRANSITION_ACTION_LABEL = "Fire Transition";

	public static final String FIRE_TRANSITION_ACTION_DESC = "Fire a transition by redistributing tokens";

	/*
	 * (non-Javadoc)
	 * 
	 * @see muvitorkit.actions.MuvitorActionBarContributor#buildActions()
	 */
	@Override
	protected void buildActions() {
		super.buildActions();

		// RetargetAction for transition firing
		final RetargetAction fireTransitionRetargetAction = new RetargetAction(
				FIRE_TRANSITION_ACTION_ID, FIRE_TRANSITION_ACTION_LABEL);
		fireTransitionRetargetAction
				.setToolTipText(FIRE_TRANSITION_ACTION_DESC);
		fireTransitionRetargetAction.setImageDescriptor(RONIconUtil
				.getDescriptor(RONIconUtil.FIRE_TRANSITION, 16));

		addRetargetAction(fireTransitionRetargetAction);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * muvitorkit.actions.MuvitorActionBarContributor#contributeToMenu(org.eclipse
	 * .jface.action.IMenuManager)
	 */
	@Override
	public void contributeToMenu(final IMenuManager menuManager) {
		super.contributeToMenu(menuManager);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * muvitorkit.actions.MuvitorActionBarContributor#contributeToToolBar(org
	 * .eclipse.jface.action.IToolBarManager)
	 */
	@Override
	public void contributeToToolBar(final IToolBarManager toolBarManager) {
		super.contributeToToolBar(toolBarManager);
		toolBarManager.add(new Separator());
		toolBarManager.add(getAction(FIRE_TRANSITION_ACTION_ID));
	}

	@Override
	protected void declareGlobalActionKeys() {
		super.declareGlobalActionKeys();
	}
}
