package roneditor.gef.actions.rule;

import org.eclipse.ui.IEditorPart;

import roneditor.ui.rule.RulePage;
import ronmodel.LHS;
import ronmodel.NAC;

/**
 * Copies the object net in the {@link LHS} to the active {@link NAC} given a
 * {@link RulePage}.
 */
public class CopyLHSToNACAction extends ObjectnetCopyAction {

	static public final String ID = "Copy LHS -> NAC";

	static private final String DESC = "Copy LHS -> NAC";

	static private final String TOOLTIP = "Copies the object net in the LHS to the active NAC";

	public CopyLHSToNACAction(final RulePage rulePage, final IEditorPart editor) {
		super(editor, rulePage);
		setId(ID);
		super.setText(DESC);
		super.setDescription(DESC);
		super.setToolTipText(TOOLTIP);
		source = getRulePage().getRule().getLhs();
	}

	@Override
	public void update() {
		target = getRulePage().getActiveNAC();
		super.update();
	}
}
