package roneditor.gef.commands;

import org.eclipse.draw2d.geometry.Point;
import org.eclipse.gef.commands.Command;

import ronmodel.Node;

/**
 * Change the location of a graphical object.
 */
public class SetConstraintCommand extends Command {

	private static final String LABEL = "Move '";

	private Point newPosition;

	private Point oldPosition;

	private final Node node;

	public SetConstraintCommand(final Node node) {
		super(LABEL + node.getName() + "'");
		this.node = node;
	}

	@Override
	public void execute() {
		oldPosition = new Point(node.getX(), node.getY());

		if (newPosition == null) {
			newPosition = oldPosition;
		}

		node.setX(newPosition.x);
		node.setY(newPosition.y);

	}

	@Override
	public void redo() {
		node.setX(newPosition.x);
		node.setY(newPosition.y);
	}

	@Override
	public void undo() {
		node.setX(oldPosition.x);
		node.setY(oldPosition.y);
	}

	/**
	 * @param newPosition
	 *            the newPosition to set
	 */
	public void setNewPosition(final Point newPosition) {
		this.newPosition = newPosition;
	}

}
