package roneditor.gef.commands.ron;

import ronmodel.HLPlace;
import ronmodel.HLPlaceType;
import ronmodel.RON;

/**
 * Command for adding a HLPlace to a RON. This is undoable.
 */
public class CreateHLPlaceCommand extends CreateHLNodeCommand {

	private static final String LABEL = "Create HLPlace ";

	private HLPlaceType type;

	public CreateHLPlaceCommand(final RON ron, final HLPlace hlPlace) {
		super(ron, hlPlace);
		setLabel(LABEL);
	}

	/**
	 * Executes the command by adding the HLPlace to the RON.
	 * 
	 * @see org.eclipse.gef.commands.Command#execute()
	 */
	@Override
	public void execute() {
		((HLPlace) getHLNode()).setType(type);
		super.execute();
	}

	/**
	 * @param type
	 *            the type to set
	 */
	public void setType(final HLPlaceType type) {
		this.type = type;
	}
}
