package roneditor.gef.commands.ron;

import ronmodel.HLTransition;
import ronmodel.HLTransitionKind;
import ronmodel.RON;

/**
 * Command for creating a transition.
 */
public class CreateHLTransitionCommand extends CreateHLNodeCommand {

	private static final String LABEL = "Create HLTrans ";

	private HLTransitionKind kind;

	public CreateHLTransitionCommand(final RON model, final HLTransition hlTrans) {
		super(model, hlTrans);
		setLabel(LABEL);
	}

	/**
	 * Executes the command by adding the HLTransition to the RON.
	 * 
	 * @see org.eclipse.gef.commands.Command#execute()
	 */
	@Override
	public void execute() {
		((HLTransition) getHLNode()).setKind(kind);
		super.execute();
	}

	/**
	 * @param kind
	 *            the kind to set
	 */
	public void setKind(final HLTransitionKind kind) {
		this.kind = kind;
	}
}
