package roneditor.gef.editparts.ron.policies;

import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.ConnectionEditPolicy;
import org.eclipse.gef.requests.GroupRequest;

import roneditor.gef.commands.ron.DeleteHLArcCommand;
import ronmodel.HLArc;

/**
 * {@link EditPolicy} for an {@link HLArc}.
 */
public class HLArcEditPolicy extends ConnectionEditPolicy {

	/**
	 * Create the appropriate DeleteHLArcCommand.
	 * 
	 * @see org.eclipse.gef.editpolicies.ConnectionEditPolicy#getDeleteCommand(org.eclipse.gef.requests.GroupRequest)
	 */
	@Override
	protected Command getDeleteCommand(final GroupRequest request) {
		return new DeleteHLArcCommand((HLArc) getHost().getModel());
	}

}
