package roneditor.gef.editpolicies;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.draw2d.BendpointLocator;
import org.eclipse.draw2d.Connection;
import org.eclipse.draw2d.geometry.PointList;
import org.eclipse.gef.ConnectionEditPart;
import org.eclipse.gef.editpolicies.SelectionHandlesEditPolicy;
import org.eclipse.gef.handles.BendpointCreationHandle;
import org.eclipse.gef.handles.BendpointHandle;

/**
 * Edit policy for Arc selections.
 */
public class ArcSelectionHandlesEditPolicy extends SelectionHandlesEditPolicy {
	// TODO ArcSelectionHandlesEditPolicy is never used!
	public ArcSelectionHandlesEditPolicy() {
		super();
	}

	/**
	 * @see org.eclipse.gef.editpolicies.SelectionHandlesEditPolicy#createSelectionHandles()
	 */
	@Override
	protected List<?> createSelectionHandles() {
		final List<BendpointHandle> list = new ArrayList<BendpointHandle>();
		final ConnectionEditPart connPart = (ConnectionEditPart) getHost();
		final PointList points = getConnection().getPoints();
		for (int i = 0; i < points.size() - 2; i++) {
			final BendpointHandle handle = new BendpointCreationHandle(
					connPart, 0, new BendpointLocator(getConnection(), i + 1));
			list.add(handle);
		}
		return list;
	}

	protected Connection getConnection() {
		return (Connection) getHostFigure();
	}
}
