package roneditor.model.properties;

import java.util.ArrayList;

import muvitorkit.properties.AbstractPropertySource;

import org.eclipse.ui.views.properties.IPropertyDescriptor;

import ronmodel.HLArc;

/**
 * Property source for a HLArc.
 */
public class HLArcPropertySource extends AbstractPropertySource<HLArc> {

	private static enum ID {
		NAME
	}

	public HLArcPropertySource(final HLArc hlArc) {
		super(hlArc);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see muvitorkit.properties.AbstractPropertySource#createDescriptors()
	 */
	@Override
	protected IPropertyDescriptor[] createPropertyDescriptors() {
		final ArrayList<IPropertyDescriptor> descriptorList = new ArrayList<IPropertyDescriptor>();
		// descriptors.add(new TextPropertyDescriptor(NAME_ID, NAME_LABEL));
		return descriptorList.toArray(new IPropertyDescriptor[] {});
	}

	/*
	 * @see
	 * org.eclipse.ui.views.properties.IPropertySource#getPropertyValue(java
	 * .lang.Object)
	 */
	@Override
	public Object getPropertyValue(final Object id) {
		if (id instanceof ID) {
			switch ((ID) id) {
			case NAME:
				return getModel().getName();
			}
		}
		return null;
	}

	/*
	 * @see
	 * org.eclipse.ui.views.properties.IPropertySource#setPropertyValue(java
	 * .lang.Object, java.lang.Object)
	 */
	@Override
	public void setPropertyValue(final Object id, final Object value) {
		switch ((ID) id) {
		case NAME:
			getModel().setName((String) value);
			break;
		default:
		}
	}

}
