package roneditor.ui.dialogs;

import muvitorkit.dialogs.AbstractFireDialog;
import muvitorkit.dialogs.TransitionSelectionTool;

import org.eclipse.gef.EditPartFactory;
import org.eclipse.gef.Tool;

import roneditor.gef.editparts.objectnet.ObjectNetEditPartFactory;
import roneditor.model.ONTransitionUtil;
import ronmodel.ONTransition;
import ronmodel.ObjectNet;

public class FireDialog extends AbstractFireDialog {

	public FireDialog(final ObjectNet objectNet) {
		super(objectNet);
	}

	@Override
	protected EditPartFactory createEditPartFactory() {
		return new ObjectNetEditPartFactory();
	}

	@Override
	protected boolean isActivated(final ONTransition transition) {
		return ONTransitionUtil.canFire(transition);
	}

	@Override
	protected Tool createTransitionSelectionTool() {
		return new TransitionSelectionTool(this);
	}

}
