package roneditor.ui.objectnet;

import java.util.Map;

import org.eclipse.gef.Request;
import org.eclipse.gef.RequestConstants;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.requests.DirectEditRequest;
import org.eclipse.gef.tools.ConnectionCreationTool;
import org.eclipse.jface.viewers.CellEditor;

import roneditor.gef.commands.objectnet.ConnectONNodesCommand;
import roneditor.gef.editparts.objectnet.ONArcEditPart;
import ronmodel.ONArc;

public class ObjectNetConnectionCreationTool extends ConnectionCreationTool {

	/**
	 * Execute {@link ConnectONNodesCommand} and finally perform an
	 * {@link DirectEditRequest}. This will then show the {@link CellEditor} for
	 * editing the {@link ONArc} weight after creation.
	 */
	@Override
	protected void executeCurrentCommand() {
		final Command command = getCurrentCommand();
		super.executeCurrentCommand();
		if (command instanceof ConnectONNodesCommand) {
			final ONArc arc = ((ConnectONNodesCommand) command).getArc();
			final Map<?, ?> reg = getCurrentViewer().getEditPartRegistry();
			final ONArcEditPart editPart = (ONArcEditPart) reg.get(arc);
			editPart.performRequest(new Request(
					RequestConstants.REQ_DIRECT_EDIT));
		}
	}

}