package roneditor.ui.objectnet;

import muvitorkit.gef.palette.MuvitorPaletteRoot;

import org.eclipse.gef.palette.PaletteGroup;

import roneditor.RONIconUtil;
import roneditor.model.ModelCreationFactory;
import ronmodel.ONArc;
import ronmodel.ONPlace;
import ronmodel.ONTransition;
import ronmodel.RonmodelPackage;

public class ObjectNetPaletteRoot extends MuvitorPaletteRoot {

	final protected PaletteGroup symbolPaletteGroup;

	public ObjectNetPaletteRoot() {
		// a new group for the editor symbols
		symbolPaletteGroup = new PaletteGroup("Symbols");
		add(symbolPaletteGroup);

		addToolEntry(symbolPaletteGroup, "Transition", "Create a transition",
				new ModelCreationFactory(ONTransition.class),
				RONIconUtil.getDescriptor(RonmodelPackage.ON_TRANSITION, 16),
				RONIconUtil.getDescriptor(RonmodelPackage.ON_TRANSITION, 24),
				ObjectNetCreationTool.class);

		addToolEntry(symbolPaletteGroup, "Place", "Create a place",
				new ModelCreationFactory(ONPlace.class),
				RONIconUtil.getDescriptor(RonmodelPackage.ON_PLACE, 16),
				RONIconUtil.getDescriptor(RonmodelPackage.ON_PLACE, 24),
				ObjectNetCreationTool.class);

		addToolEntry(symbolPaletteGroup, "Arc", "Create an arc",
				new ModelCreationFactory(ONArc.class),
				RONIconUtil.getDescriptor(RonmodelPackage.ON_ARC, 16),
				RONIconUtil.getDescriptor(RonmodelPackage.ON_ARC, 24),
				ObjectNetConnectionCreationTool.class);

		addToolEntry(symbolPaletteGroup, "MagicArc",
				"Creates a arc in magic way", new ModelCreationFactory(
						ONArc.class), RONIconUtil.getDescriptor(
						RONIconUtil.MAGIC_ARC, 16), RONIconUtil.getDescriptor(
						RONIconUtil.MAGIC_ARC, 24),
				ObjectNetMagicConnectionCreationTool.class);
	}
}
