package roneditor.ui.ron;

import java.util.Map;

import org.eclipse.gef.EditPart;
import org.eclipse.gef.Request;
import org.eclipse.gef.RequestConstants;
import org.eclipse.gef.tools.CreationTool;

import roneditor.gef.commands.ron.CreateHLNodeCommand;
import roneditor.gef.commands.ron.CreateHLPlaceCommand;
import ronmodel.HLNode;
import ronmodel.HLPlaceType;

public class HLPlaceCreationTool extends CreationTool {

	public static final Object PROPERTY_HLPLACE_TYPE = "type";

	private HLPlaceType type;

	@Override
	protected void executeCurrentCommand() {
		// Store current command
		final CreateHLPlaceCommand command = (CreateHLPlaceCommand) getCurrentCommand();
		if (getType() != null && command != null) {
			command.setType(getType());
		}
		super.executeCurrentCommand();

		// directEdit
		if (command != null) {
			final HLNode node = ((CreateHLNodeCommand) command).getHLNode();
			final Map<?, ?> reg = getCurrentViewer().getEditPartRegistry();
			final EditPart editPart = (EditPart) reg.get(node);
			final Request request = new Request(
					RequestConstants.REQ_DIRECT_EDIT);
			editPart.performRequest(request);
			command.setLabel(command.getLabel() + "'" + node.getName() + "'");
		}
	}

	/**
	 * @return the type
	 */
	public HLPlaceType getType() {
		return type;
	}

	/**
	 * @param type
	 *            the type to set
	 */
	public void setType(final HLPlaceType type) {
		this.type = type;
	}

}