package roneditor.ui.ron;

import muvitorkit.gef.palette.MuvitorPaletteRoot;

import org.eclipse.gef.palette.PaletteGroup;
import org.eclipse.gef.palette.ToolEntry;
import org.eclipse.gef.tools.ConnectionCreationTool;
import org.eclipse.gef.tools.CreationTool;

import roneditor.RONIconUtil;
import roneditor.model.ModelCreationFactory;
import ronmodel.HLArc;
import ronmodel.HLPlace;
import ronmodel.HLPlaceType;
import ronmodel.HLTransition;
import ronmodel.HLTransitionKind;
import ronmodel.RonmodelPackage;
import ronmodel.Token;

public class RONPaletteRoot extends MuvitorPaletteRoot {

	public RONPaletteRoot() {
		// a group for the editor symbols
		final PaletteGroup symbols = new PaletteGroup("Symbols");
		add(symbols);

		ToolEntry entry;

		entry = addToolEntry(symbols, "STANDARD",
				"Create a STANDARD transition", new ModelCreationFactory(
						HLTransition.class), RONIconUtil.getDescriptor(
						RonmodelPackage.HL_TRANSITION,
						HLTransitionKind.STANDARD, 16),
				RONIconUtil.getDescriptor(RonmodelPackage.HL_TRANSITION,
						HLTransitionKind.STANDARD, 24),
				HLTransitionCreationTool.class);
		entry.setToolProperty(
				HLTransitionCreationTool.PROPERTY_HLTRANSITION_KIND,
				HLTransitionKind.STANDARD_LITERAL);

		entry = addToolEntry(symbols, "FIRE", "Create a FIRE transition",
				new ModelCreationFactory(HLTransition.class),
				RONIconUtil.getDescriptor(RonmodelPackage.HL_TRANSITION,
						HLTransitionKind.FIRE, 16), RONIconUtil.getDescriptor(
						RonmodelPackage.HL_TRANSITION, HLTransitionKind.FIRE,
						24), HLTransitionCreationTool.class);
		entry.setToolProperty(
				HLTransitionCreationTool.PROPERTY_HLTRANSITION_KIND,
				HLTransitionKind.FIRE_LITERAL);

		entry = addToolEntry(symbols, "APPLYRULE",
				"Create a APPLYRULE transition", new ModelCreationFactory(
						HLTransition.class), RONIconUtil.getDescriptor(
						RonmodelPackage.HL_TRANSITION,
						HLTransitionKind.APPLYRULE, 16),
				RONIconUtil.getDescriptor(RonmodelPackage.HL_TRANSITION,
						HLTransitionKind.APPLYRULE, 24),
				HLTransitionCreationTool.class);
		entry.setToolProperty(
				HLTransitionCreationTool.PROPERTY_HLTRANSITION_KIND,
				HLTransitionKind.APPLYRULE_LITERAL);

		entry = addToolEntry(symbols, "SPLIT", "Create a SPLIT transition",
				new ModelCreationFactory(HLTransition.class),
				RONIconUtil.getDescriptor(RonmodelPackage.HL_TRANSITION,
						HLTransitionKind.SPLIT, 16), RONIconUtil.getDescriptor(
						RonmodelPackage.HL_TRANSITION, HLTransitionKind.SPLIT,
						24), HLTransitionCreationTool.class);
		entry.setToolProperty(
				HLTransitionCreationTool.PROPERTY_HLTRANSITION_KIND,
				HLTransitionKind.SPLIT_LITERAL);

		entry = addToolEntry(symbols, "ObjectNetPlace",
				"Create a place for a objectNets", new ModelCreationFactory(
						HLPlace.class), RONIconUtil.getDescriptor(
						RonmodelPackage.HL_PLACE, HLPlaceType.NET, 16),
				RONIconUtil.getDescriptor(RonmodelPackage.HL_PLACE,
						HLPlaceType.NET, 24), HLPlaceCreationTool.class);
		entry.setToolProperty(HLPlaceCreationTool.PROPERTY_HLPLACE_TYPE,
				HLPlaceType.NET_LITERAL);

		entry = addToolEntry(symbols, "RulePlace", "Create a place for a rule",
				new ModelCreationFactory(HLPlace.class),
				RONIconUtil.getDescriptor(RonmodelPackage.HL_PLACE,
						HLPlaceType.RULE, 16), RONIconUtil.getDescriptor(
						RonmodelPackage.HL_PLACE, HLPlaceType.RULE, 24),
				HLPlaceCreationTool.class);
		entry.setToolProperty(HLPlaceCreationTool.PROPERTY_HLPLACE_TYPE,
				HLPlaceType.RULE_LITERAL);

		entry = addToolEntry(symbols, "Token", "Create a token",
				new ModelCreationFactory(Token.class),
				RONIconUtil.getDescriptor(RONIconUtil.TOKEN, 16),
				RONIconUtil.getDescriptor(RONIconUtil.TOKEN, 24),
				CreationTool.class);

		entry = addToolEntry(symbols, "Arc", "Create an arc",
				new ModelCreationFactory(HLArc.class),
				RONIconUtil.getDescriptor(RonmodelPackage.HL_ARC, 16),
				RONIconUtil.getDescriptor(RonmodelPackage.HL_ARC, 24),
				ConnectionCreationTool.class);
	}
}
