/**
 * <copyright>
 * </copyright>
 *
 * $Id: ONArc.java,v 1.11 2010/08/20 22:16:34 modica Exp $
 */
package ronmodel;

import org.eclipse.emf.ecore.ENamedElement;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>ON Arc</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link ronmodel.ONArc#getSource <em>Source</em>}</li>
 * <li>{@link ronmodel.ONArc#getTarget <em>Target</em>}</li>
 * <li>{@link ronmodel.ONArc#getObjectNet <em>Object Net</em>}</li>
 * <li>{@link ronmodel.ONArc#getWeight <em>Weight</em>}</li>
 * </ul>
 * </p>
 * 
 * @see ronmodel.RonmodelPackage#getONArc()
 * @model
 * @generated
 */
public interface ONArc extends ENamedElement {
	/**
	 * Returns the value of the '<em><b>Source</b></em>' reference. It is
	 * bidirectional and its opposite is '{@link ronmodel.ONNode#getOutgoing
	 * <em>Outgoing</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Source</em>' reference isn't clear, there
	 * really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Source</em>' reference.
	 * @see #setSource(ONNode)
	 * @see ronmodel.RonmodelPackage#getONArc_Source()
	 * @see ronmodel.ONNode#getOutgoing
	 * @model opposite="outgoing"
	 * @generated
	 */
	ONNode getSource();

	/**
	 * Sets the value of the '{@link ronmodel.ONArc#getSource <em>Source</em>}'
	 * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Source</em>' reference.
	 * @see #getSource()
	 * @generated
	 */
	void setSource(ONNode value);

	/**
	 * Returns the value of the '<em><b>Target</b></em>' reference. It is
	 * bidirectional and its opposite is '{@link ronmodel.ONNode#getIncoming
	 * <em>Incoming</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Target</em>' reference isn't clear, there
	 * really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Target</em>' reference.
	 * @see #setTarget(ONNode)
	 * @see ronmodel.RonmodelPackage#getONArc_Target()
	 * @see ronmodel.ONNode#getIncoming
	 * @model opposite="incoming"
	 * @generated
	 */
	ONNode getTarget();

	/**
	 * Sets the value of the '{@link ronmodel.ONArc#getTarget <em>Target</em>}'
	 * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Target</em>' reference.
	 * @see #getTarget()
	 * @generated
	 */
	void setTarget(ONNode value);

	/**
	 * Returns the value of the '<em><b>Object Net</b></em>' container
	 * reference. It is bidirectional and its opposite is '
	 * {@link ronmodel.ObjectNet#getArcs <em>Arcs</em>}'. <!-- begin-user-doc
	 * -->
	 * <p>
	 * If the meaning of the '<em>Object Net</em>' container reference isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Object Net</em>' container reference.
	 * @see #setObjectNet(ObjectNet)
	 * @see ronmodel.RonmodelPackage#getONArc_ObjectNet()
	 * @see ronmodel.ObjectNet#getArcs
	 * @model opposite="arcs" transient="false"
	 * @generated
	 */
	ObjectNet getObjectNet();

	/**
	 * Sets the value of the '{@link ronmodel.ONArc#getObjectNet
	 * <em>Object Net</em>}' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Object Net</em>' container
	 *            reference.
	 * @see #getObjectNet()
	 * @generated
	 */
	void setObjectNet(ObjectNet value);

	/**
	 * Returns the value of the '<em><b>Weight</b></em>' attribute. The default
	 * value is <code>"1"</code>. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Weight</em>' attribute isn't clear, there
	 * really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Weight</em>' attribute.
	 * @see #setWeight(int)
	 * @see ronmodel.RonmodelPackage#getONArc_Weight()
	 * @model default="1" required="true"
	 * @generated
	 */
	int getWeight();

	/**
	 * Sets the value of the '{@link ronmodel.ONArc#getWeight <em>Weight</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Weight</em>' attribute.
	 * @see #getWeight()
	 * @generated
	 */
	void setWeight(int value);

} // ONArc
