/**
 * <copyright>
 * </copyright>
 *
 * $Id: ONNode.java,v 1.13 2009/07/21 19:13:51 modica Exp $
 */
package ronmodel;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>ON Node</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link ronmodel.ONNode#getOutgoing <em>Outgoing</em>}</li>
 * <li>{@link ronmodel.ONNode#getIncoming <em>Incoming</em>}</li>
 * <li>{@link ronmodel.ONNode#getObjectNet <em>Object Net</em>}</li>
 * <li>{@link ronmodel.ONNode#getIsSourceInMappings <em>Is Source In Mappings
 * </em>}</li>
 * <li>{@link ronmodel.ONNode#getIsTargetInMappings <em>Is Target In Mappings
 * </em>}</li>
 * <li>{@link ronmodel.ONNode#getColor <em>Color</em>}</li>
 * </ul>
 * </p>
 * 
 * @see ronmodel.RonmodelPackage#getONNode()
 * @model abstract="true"
 * @generated
 */
public interface ONNode extends Node {
	/**
	 * Returns the value of the '<em><b>Outgoing</b></em>' reference list. The
	 * list contents are of type {@link ronmodel.ONArc}. It is bidirectional and
	 * its opposite is '{@link ronmodel.ONArc#getSource <em>Source</em>}'. <!--
	 * begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Outgoing</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Outgoing</em>' reference list.
	 * @see ronmodel.RonmodelPackage#getONNode_Outgoing()
	 * @see ronmodel.ONArc#getSource
	 * @model opposite="source"
	 * @generated
	 */
	EList<ONArc> getOutgoing();

	/**
	 * Returns the value of the '<em><b>Incoming</b></em>' reference list. The
	 * list contents are of type {@link ronmodel.ONArc}. It is bidirectional and
	 * its opposite is '{@link ronmodel.ONArc#getTarget <em>Target</em>}'. <!--
	 * begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Incoming</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Incoming</em>' reference list.
	 * @see ronmodel.RonmodelPackage#getONNode_Incoming()
	 * @see ronmodel.ONArc#getTarget
	 * @model opposite="target"
	 * @generated
	 */
	EList<ONArc> getIncoming();

	/**
	 * Returns the value of the '<em><b>Object Net</b></em>' container
	 * reference. It is bidirectional and its opposite is '
	 * {@link ronmodel.ObjectNet#getNodes <em>Nodes</em>}'. <!-- begin-user-doc
	 * -->
	 * <p>
	 * If the meaning of the '<em>Object Net</em>' container reference isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Object Net</em>' container reference.
	 * @see #setObjectNet(ObjectNet)
	 * @see ronmodel.RonmodelPackage#getONNode_ObjectNet()
	 * @see ronmodel.ObjectNet#getNodes
	 * @model opposite="nodes" transient="false"
	 * @generated
	 */
	ObjectNet getObjectNet();

	/**
	 * Sets the value of the '{@link ronmodel.ONNode#getObjectNet
	 * <em>Object Net</em>}' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Object Net</em>' container
	 *            reference.
	 * @see #getObjectNet()
	 * @generated
	 */
	void setObjectNet(ObjectNet value);

	/**
	 * Returns the value of the '<em><b>Is Source In Mappings</b></em>'
	 * reference list. The list contents are of type {@link ronmodel.Mapping}.
	 * It is bidirectional and its opposite is '
	 * {@link ronmodel.Mapping#getSource <em>Source</em>}'. <!-- begin-user-doc
	 * -->
	 * <p>
	 * If the meaning of the '<em>Is Source In Mappings</em>' reference list
	 * isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Is Source In Mappings</em>' reference list.
	 * @see ronmodel.RonmodelPackage#getONNode_IsSourceInMappings()
	 * @see ronmodel.Mapping#getSource
	 * @model opposite="source"
	 * @generated
	 */
	EList<Mapping> getIsSourceInMappings();

	/**
	 * Returns the value of the '<em><b>Is Target In Mappings</b></em>'
	 * reference list. The list contents are of type {@link ronmodel.Mapping}.
	 * It is bidirectional and its opposite is '
	 * {@link ronmodel.Mapping#getTarget <em>Target</em>}'. <!-- begin-user-doc
	 * -->
	 * <p>
	 * If the meaning of the '<em>Is Target In Mappings</em>' reference list
	 * isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Is Target In Mappings</em>' reference list.
	 * @see ronmodel.RonmodelPackage#getONNode_IsTargetInMappings()
	 * @see ronmodel.Mapping#getTarget
	 * @model opposite="target"
	 * @generated
	 */
	EList<Mapping> getIsTargetInMappings();

	/**
	 * Returns the value of the '<em><b>Color</b></em>' containment reference.
	 * It is bidirectional and its opposite is '
	 * {@link ronmodel.NodeColor#getNode <em>Node</em>}'. <!-- begin-user-doc
	 * -->
	 * <p>
	 * If the meaning of the '<em>Color</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Color</em>' containment reference.
	 * @see #setColor(NodeColor)
	 * @see ronmodel.RonmodelPackage#getONNode_Color()
	 * @see ronmodel.NodeColor#getNode
	 * @model opposite="node" containment="true" required="true"
	 * @generated
	 */
	NodeColor getColor();

	/**
	 * Sets the value of the '{@link ronmodel.ONNode#getColor <em>Color</em>}'
	 * containment reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Color</em>' containment reference.
	 * @see #getColor()
	 * @generated
	 */
	void setColor(NodeColor value);

} // ONNode
