/**
 * <copyright>
 * </copyright>
 *
 * $Id: ONNodeImpl.java,v 1.14 2010/08/20 22:16:34 modica Exp $
 */
package ronmodel.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import ronmodel.Mapping;
import ronmodel.NodeColor;
import ronmodel.ONArc;
import ronmodel.ONNode;
import ronmodel.ObjectNet;
import ronmodel.RonmodelPackage;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>ON Node</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>{@link ronmodel.impl.ONNodeImpl#getOutgoing <em>Outgoing</em>}</li>
 * <li>{@link ronmodel.impl.ONNodeImpl#getIncoming <em>Incoming</em>}</li>
 * <li>{@link ronmodel.impl.ONNodeImpl#getObjectNet <em>Object Net</em>}</li>
 * <li>{@link ronmodel.impl.ONNodeImpl#getIsSourceInMappings <em>Is Source In
 * Mappings</em>}</li>
 * <li>{@link ronmodel.impl.ONNodeImpl#getIsTargetInMappings <em>Is Target In
 * Mappings</em>}</li>
 * <li>{@link ronmodel.impl.ONNodeImpl#getColor <em>Color</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public abstract class ONNodeImpl extends NodeImpl implements ONNode {
	/**
	 * The cached value of the '{@link #getOutgoing() <em>Outgoing</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getOutgoing()
	 * @generated
	 * @ordered
	 */
	protected EList<ONArc> outgoing;

	/**
	 * The cached value of the '{@link #getIncoming() <em>Incoming</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getIncoming()
	 * @generated
	 * @ordered
	 */
	protected EList<ONArc> incoming;

	/**
	 * The cached value of the '{@link #getIsSourceInMappings()
	 * <em>Is Source In Mappings</em>}' reference list. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see #getIsSourceInMappings()
	 * @generated
	 * @ordered
	 */
	protected EList<Mapping> isSourceInMappings;

	/**
	 * The cached value of the '{@link #getIsTargetInMappings()
	 * <em>Is Target In Mappings</em>}' reference list. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see #getIsTargetInMappings()
	 * @generated
	 * @ordered
	 */
	protected EList<Mapping> isTargetInMappings;

	/**
	 * The cached value of the '{@link #getColor() <em>Color</em>}' containment
	 * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getColor()
	 * @generated
	 * @ordered
	 */
	protected NodeColor color;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected ONNodeImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return RonmodelPackage.Literals.ON_NODE;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public EList<ONArc> getOutgoing() {
		if (outgoing == null) {
			outgoing = new EObjectWithInverseResolvingEList<ONArc>(ONArc.class,
					this, RonmodelPackage.ON_NODE__OUTGOING,
					RonmodelPackage.ON_ARC__SOURCE);
		}
		return outgoing;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public EList<ONArc> getIncoming() {
		if (incoming == null) {
			incoming = new EObjectWithInverseResolvingEList<ONArc>(ONArc.class,
					this, RonmodelPackage.ON_NODE__INCOMING,
					RonmodelPackage.ON_ARC__TARGET);
		}
		return incoming;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public ObjectNet getObjectNet() {
		if (eContainerFeatureID() != RonmodelPackage.ON_NODE__OBJECT_NET) {
			return null;
		}
		return (ObjectNet) eContainer();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetObjectNet(final ObjectNet newObjectNet,
			NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject) newObjectNet,
				RonmodelPackage.ON_NODE__OBJECT_NET, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void setObjectNet(final ObjectNet newObjectNet) {
		if (newObjectNet != eInternalContainer()
				|| eContainerFeatureID() != RonmodelPackage.ON_NODE__OBJECT_NET
				&& newObjectNet != null) {
			if (EcoreUtil.isAncestor(this, newObjectNet)) {
				throw new IllegalArgumentException(
						"Recursive containment not allowed for " + toString());
			}
			NotificationChain msgs = null;
			if (eInternalContainer() != null) {
				msgs = eBasicRemoveFromContainer(msgs);
			}
			if (newObjectNet != null) {
				msgs = ((InternalEObject) newObjectNet).eInverseAdd(this,
						RonmodelPackage.OBJECT_NET__NODES, ObjectNet.class,
						msgs);
			}
			msgs = basicSetObjectNet(newObjectNet, msgs);
			if (msgs != null) {
				msgs.dispatch();
			}
		} else if (eNotificationRequired()) {
			eNotify(new ENotificationImpl(this, Notification.SET,
					RonmodelPackage.ON_NODE__OBJECT_NET, newObjectNet,
					newObjectNet));
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public EList<Mapping> getIsSourceInMappings() {
		if (isSourceInMappings == null) {
			isSourceInMappings = new EObjectWithInverseResolvingEList<Mapping>(
					Mapping.class, this,
					RonmodelPackage.ON_NODE__IS_SOURCE_IN_MAPPINGS,
					RonmodelPackage.MAPPING__SOURCE);
		}
		return isSourceInMappings;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public EList<Mapping> getIsTargetInMappings() {
		if (isTargetInMappings == null) {
			isTargetInMappings = new EObjectWithInverseResolvingEList<Mapping>(
					Mapping.class, this,
					RonmodelPackage.ON_NODE__IS_TARGET_IN_MAPPINGS,
					RonmodelPackage.MAPPING__TARGET);
		}
		return isTargetInMappings;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NodeColor getColor() {
		return color;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetColor(final NodeColor newColor,
			NotificationChain msgs) {
		final NodeColor oldColor = color;
		color = newColor;
		if (eNotificationRequired()) {
			final ENotificationImpl notification = new ENotificationImpl(this,
					Notification.SET, RonmodelPackage.ON_NODE__COLOR, oldColor,
					newColor);
			if (msgs == null) {
				msgs = notification;
			} else {
				msgs.add(notification);
			}
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void setColor(final NodeColor newColor) {
		if (newColor != color) {
			NotificationChain msgs = null;
			if (color != null) {
				msgs = ((InternalEObject) color)
						.eInverseRemove(this, RonmodelPackage.NODE_COLOR__NODE,
								NodeColor.class, msgs);
			}
			if (newColor != null) {
				msgs = ((InternalEObject) newColor)
						.eInverseAdd(this, RonmodelPackage.NODE_COLOR__NODE,
								NodeColor.class, msgs);
			}
			msgs = basicSetColor(newColor, msgs);
			if (msgs != null) {
				msgs.dispatch();
			}
		} else if (eNotificationRequired()) {
			eNotify(new ENotificationImpl(this, Notification.SET,
					RonmodelPackage.ON_NODE__COLOR, newColor, newColor));
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(final InternalEObject otherEnd,
			final int featureID, NotificationChain msgs) {
		switch (featureID) {
		case RonmodelPackage.ON_NODE__OUTGOING:
			return ((InternalEList<InternalEObject>) (InternalEList<?>) getOutgoing())
					.basicAdd(otherEnd, msgs);
		case RonmodelPackage.ON_NODE__INCOMING:
			return ((InternalEList<InternalEObject>) (InternalEList<?>) getIncoming())
					.basicAdd(otherEnd, msgs);
		case RonmodelPackage.ON_NODE__OBJECT_NET:
			if (eInternalContainer() != null) {
				msgs = eBasicRemoveFromContainer(msgs);
			}
			return basicSetObjectNet((ObjectNet) otherEnd, msgs);
		case RonmodelPackage.ON_NODE__IS_SOURCE_IN_MAPPINGS:
			return ((InternalEList<InternalEObject>) (InternalEList<?>) getIsSourceInMappings())
					.basicAdd(otherEnd, msgs);
		case RonmodelPackage.ON_NODE__IS_TARGET_IN_MAPPINGS:
			return ((InternalEList<InternalEObject>) (InternalEList<?>) getIsTargetInMappings())
					.basicAdd(otherEnd, msgs);
		case RonmodelPackage.ON_NODE__COLOR:
			if (color != null) {
				msgs = ((InternalEObject) color)
						.eInverseRemove(this, EOPPOSITE_FEATURE_BASE
								- RonmodelPackage.ON_NODE__COLOR, null, msgs);
			}
			return basicSetColor((NodeColor) otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(final InternalEObject otherEnd,
			final int featureID, final NotificationChain msgs) {
		switch (featureID) {
		case RonmodelPackage.ON_NODE__OUTGOING:
			return ((InternalEList<?>) getOutgoing()).basicRemove(otherEnd,
					msgs);
		case RonmodelPackage.ON_NODE__INCOMING:
			return ((InternalEList<?>) getIncoming()).basicRemove(otherEnd,
					msgs);
		case RonmodelPackage.ON_NODE__OBJECT_NET:
			return basicSetObjectNet(null, msgs);
		case RonmodelPackage.ON_NODE__IS_SOURCE_IN_MAPPINGS:
			return ((InternalEList<?>) getIsSourceInMappings()).basicRemove(
					otherEnd, msgs);
		case RonmodelPackage.ON_NODE__IS_TARGET_IN_MAPPINGS:
			return ((InternalEList<?>) getIsTargetInMappings()).basicRemove(
					otherEnd, msgs);
		case RonmodelPackage.ON_NODE__COLOR:
			return basicSetColor(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(
			final NotificationChain msgs) {
		switch (eContainerFeatureID()) {
		case RonmodelPackage.ON_NODE__OBJECT_NET:
			return eInternalContainer().eInverseRemove(this,
					RonmodelPackage.OBJECT_NET__NODES, ObjectNet.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Object eGet(final int featureID, final boolean resolve,
			final boolean coreType) {
		switch (featureID) {
		case RonmodelPackage.ON_NODE__OUTGOING:
			return getOutgoing();
		case RonmodelPackage.ON_NODE__INCOMING:
			return getIncoming();
		case RonmodelPackage.ON_NODE__OBJECT_NET:
			return getObjectNet();
		case RonmodelPackage.ON_NODE__IS_SOURCE_IN_MAPPINGS:
			return getIsSourceInMappings();
		case RonmodelPackage.ON_NODE__IS_TARGET_IN_MAPPINGS:
			return getIsTargetInMappings();
		case RonmodelPackage.ON_NODE__COLOR:
			return getColor();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(final int featureID, final Object newValue) {
		switch (featureID) {
		case RonmodelPackage.ON_NODE__OUTGOING:
			getOutgoing().clear();
			getOutgoing().addAll((Collection<? extends ONArc>) newValue);
			return;
		case RonmodelPackage.ON_NODE__INCOMING:
			getIncoming().clear();
			getIncoming().addAll((Collection<? extends ONArc>) newValue);
			return;
		case RonmodelPackage.ON_NODE__OBJECT_NET:
			setObjectNet((ObjectNet) newValue);
			return;
		case RonmodelPackage.ON_NODE__IS_SOURCE_IN_MAPPINGS:
			getIsSourceInMappings().clear();
			getIsSourceInMappings().addAll(
					(Collection<? extends Mapping>) newValue);
			return;
		case RonmodelPackage.ON_NODE__IS_TARGET_IN_MAPPINGS:
			getIsTargetInMappings().clear();
			getIsTargetInMappings().addAll(
					(Collection<? extends Mapping>) newValue);
			return;
		case RonmodelPackage.ON_NODE__COLOR:
			setColor((NodeColor) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void eUnset(final int featureID) {
		switch (featureID) {
		case RonmodelPackage.ON_NODE__OUTGOING:
			getOutgoing().clear();
			return;
		case RonmodelPackage.ON_NODE__INCOMING:
			getIncoming().clear();
			return;
		case RonmodelPackage.ON_NODE__OBJECT_NET:
			setObjectNet((ObjectNet) null);
			return;
		case RonmodelPackage.ON_NODE__IS_SOURCE_IN_MAPPINGS:
			getIsSourceInMappings().clear();
			return;
		case RonmodelPackage.ON_NODE__IS_TARGET_IN_MAPPINGS:
			getIsTargetInMappings().clear();
			return;
		case RonmodelPackage.ON_NODE__COLOR:
			setColor((NodeColor) null);
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public boolean eIsSet(final int featureID) {
		switch (featureID) {
		case RonmodelPackage.ON_NODE__OUTGOING:
			return outgoing != null && !outgoing.isEmpty();
		case RonmodelPackage.ON_NODE__INCOMING:
			return incoming != null && !incoming.isEmpty();
		case RonmodelPackage.ON_NODE__OBJECT_NET:
			return getObjectNet() != null;
		case RonmodelPackage.ON_NODE__IS_SOURCE_IN_MAPPINGS:
			return isSourceInMappings != null && !isSourceInMappings.isEmpty();
		case RonmodelPackage.ON_NODE__IS_TARGET_IN_MAPPINGS:
			return isTargetInMappings != null && !isTargetInMappings.isEmpty();
		case RonmodelPackage.ON_NODE__COLOR:
			return color != null;
		}
		return super.eIsSet(featureID);
	}

} // ONNodeImpl
