/**
 * <copyright>
 * </copyright>
 *
 * $Id: RonmodelFactoryImpl.java,v 1.13 2010/08/20 22:16:34 modica Exp $
 */
package ronmodel.impl;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.impl.EFactoryImpl;
import org.eclipse.emf.ecore.plugin.EcorePlugin;

import ronmodel.HLArc;
import ronmodel.HLPlace;
import ronmodel.HLPlaceType;
import ronmodel.HLTransition;
import ronmodel.HLTransitionKind;
import ronmodel.LHS;
import ronmodel.Mapping;
import ronmodel.NAC;
import ronmodel.Node;
import ronmodel.NodeColor;
import ronmodel.ONArc;
import ronmodel.ONPlace;
import ronmodel.ONTransition;
import ronmodel.ObjectNet;
import ronmodel.RHS;
import ronmodel.RON;
import ronmodel.RonmodelFactory;
import ronmodel.RonmodelPackage;
import ronmodel.Rule;

/**
 * <!-- begin-user-doc --> An implementation of the model <b>Factory</b>. <!--
 * end-user-doc -->
 * 
 * @generated
 */
public class RonmodelFactoryImpl extends EFactoryImpl implements
		RonmodelFactory {
	/**
	 * Creates the default factory implementation. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	public static RonmodelFactory init() {
		try {
			final RonmodelFactory theRonmodelFactory = (RonmodelFactory) EPackage.Registry.INSTANCE
					.getEFactory("http://ronmodel");
			if (theRonmodelFactory != null) {
				return theRonmodelFactory;
			}
		} catch (final Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new RonmodelFactoryImpl();
	}

	/**
	 * Creates an instance of the factory. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	public RonmodelFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public EObject create(final EClass eClass) {
		switch (eClass.getClassifierID()) {
		case RonmodelPackage.RON:
			return createRON();
		case RonmodelPackage.NODE:
			return createNode();
		case RonmodelPackage.HL_PLACE:
			return createHLPlace();
		case RonmodelPackage.HL_TRANSITION:
			return createHLTransition();
		case RonmodelPackage.HL_ARC:
			return createHLArc();
		case RonmodelPackage.OBJECT_NET:
			return createObjectNet();
		case RonmodelPackage.ON_PLACE:
			return createONPlace();
		case RonmodelPackage.ON_TRANSITION:
			return createONTransition();
		case RonmodelPackage.ON_ARC:
			return createONArc();
		case RonmodelPackage.RULE:
			return createRule();
		case RonmodelPackage.MAPPING:
			return createMapping();
		case RonmodelPackage.LHS:
			return createLHS();
		case RonmodelPackage.RHS:
			return createRHS();
		case RonmodelPackage.NAC:
			return createNAC();
		case RonmodelPackage.NODE_COLOR:
			return createNodeColor();
		default:
			throw new IllegalArgumentException("The class '" + eClass.getName()
					+ "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Object createFromString(final EDataType eDataType,
			final String initialValue) {
		switch (eDataType.getClassifierID()) {
		case RonmodelPackage.HL_PLACE_TYPE:
			return createHLPlaceTypeFromString(eDataType, initialValue);
		case RonmodelPackage.HL_TRANSITION_KIND:
			return createHLTransitionKindFromString(eDataType, initialValue);
		default:
			throw new IllegalArgumentException("The datatype '"
					+ eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public String convertToString(final EDataType eDataType,
			final Object instanceValue) {
		switch (eDataType.getClassifierID()) {
		case RonmodelPackage.HL_PLACE_TYPE:
			return convertHLPlaceTypeToString(eDataType, instanceValue);
		case RonmodelPackage.HL_TRANSITION_KIND:
			return convertHLTransitionKindToString(eDataType, instanceValue);
		default:
			throw new IllegalArgumentException("The datatype '"
					+ eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public RON createRON() {
		final RONImpl ron = new RONImpl();
		return ron;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Node createNode() {
		final NodeImpl node = new NodeImpl();
		return node;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public HLPlace createHLPlace() {
		final HLPlaceImpl hlPlace = new HLPlaceImpl();
		return hlPlace;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public HLTransition createHLTransition() {
		final HLTransitionImpl hlTransition = new HLTransitionImpl();
		return hlTransition;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 */
	@Override
	public HLArc createHLArc() {
		final HLArcImpl hlArc = new HLArcImpl();
		hlArc.setName("");
		return hlArc;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 */
	@Override
	public ObjectNet createObjectNet() {
		final ObjectNetImpl objectNet = new ObjectNetImpl();
		objectNet.setName("");
		return objectNet;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public ONPlace createONPlace() {
		final ONPlaceImpl onPlace = new ONPlaceImpl();
		return onPlace;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public ONTransition createONTransition() {
		final ONTransitionImpl onTransition = new ONTransitionImpl();
		return onTransition;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public ONArc createONArc() {
		final ONArcImpl onArc = new ONArcImpl();
		return onArc;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Rule createRule() {
		final RuleImpl rule = new RuleImpl();
		return rule;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Mapping createMapping() {
		final MappingImpl mapping = new MappingImpl();
		return mapping;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public LHS createLHS() {
		final LHSImpl lhs = new LHSImpl();
		return lhs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public RHS createRHS() {
		final RHSImpl rhs = new RHSImpl();
		return rhs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NAC createNAC() {
		final NACImpl nac = new NACImpl();
		return nac;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NodeColor createNodeColor() {
		final NodeColorImpl nodeColor = new NodeColorImpl();
		return nodeColor;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public HLPlaceType createHLPlaceTypeFromString(final EDataType eDataType,
			final String initialValue) {
		final HLPlaceType result = HLPlaceType.get(initialValue);
		if (result == null) {
			throw new IllegalArgumentException("The value '" + initialValue
					+ "' is not a valid enumerator of '" + eDataType.getName()
					+ "'");
		}
		return result;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String convertHLPlaceTypeToString(final EDataType eDataType,
			final Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public HLTransitionKind createHLTransitionKindFromString(
			final EDataType eDataType, final String initialValue) {
		final HLTransitionKind result = HLTransitionKind.get(initialValue);
		if (result == null) {
			throw new IllegalArgumentException("The value '" + initialValue
					+ "' is not a valid enumerator of '" + eDataType.getName()
					+ "'");
		}
		return result;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String convertHLTransitionKindToString(final EDataType eDataType,
			final Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public RonmodelPackage getRonmodelPackage() {
		return (RonmodelPackage) getEPackage();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static RonmodelPackage getPackage() {
		return RonmodelPackage.eINSTANCE;
	}

} // RonmodelFactoryImpl
